#ifndef LQMEAS_LTRRESOLVER_H
#define LQMEAS_LTRRESOLVER_H

#include <QList>
#include <QStringList>
#include <QSharedPointer>

#include "lqmeas/devs/resolver/DevicesResolver.h"

namespace LQMeas {
    class LtrModule;
    class LtrCrate;
    class Device;
    class DeviceValidator;

    class LtrResolver : public DevicesResolver {
    public:
        QList<QSharedPointer<LtrModule> > getModuleList(QStringList nameFilter);
        QList<QSharedPointer<LtrModule> > getModuleList(const DeviceValidator* validator);

        QList<QSharedPointer<LtrCrate> > getCratesList();

        QList<QSharedPointer<Device> > getDevList();

        static LtrResolver* resolver();

    private:
        LtrResolver();
        QList< QSharedPointer<LtrCrate> > m_crates;

        QSharedPointer<LtrCrate> getCrate(QString serial);
        static QSharedPointer<LtrModule> createModule(QSharedPointer<LtrCrate> getCrate, unsigned slot, quint16 mid);

        friend class LtrCrate;
    };
}

#endif // LTRRESOLVER_H
